ExceptionRequest (Java SE 17 & JDK 17)
Description: declaration: module: jdk.jdi, package: com.sun.jdi.request, interface: ExceptionRequest
Keywords: com.sun.jdi.request.ExceptionRequest interface

Module jdk.jdi
Package com.sun.jdi.request

# Interface ExceptionRequest

All Superinterfaces:
  `EventRequest`, `Mirror`

public interface ExceptionRequest extends EventRequest
Request for notification when an exception occurs in the target VM. When an enabled ExceptionRequest is satisfied, an `event set` containing an `ExceptionEvent` will be placed on the `EventQueue`. The collection of existing ExceptionRequests is managed by the `EventRequestManager`

Since:
  1.3
See Also:
  - `ExceptionEvent`
  - `EventQueue`
  - `EventRequestManager`

- ## Field Summary

  ### Fields declared in interface com.sun.jdi.request.EventRequest

  `SUSPEND_ALL, SUSPEND_EVENT_THREAD, SUSPEND_NONE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addClassExclusionFilter(String classPattern)`
  Restricts the events generated by this request to those whose location is in a class whose name does not match a restricted regular expression.
  `void`
  `addClassFilter(ReferenceType refType)`
  Restricts the events generated by this request to those whose location is in the given reference type or any of its subtypes.
  `void`
  `addClassFilter(String classPattern)`
  Restricts the events generated by this request to those whose location is in a class whose name matches a restricted regular expression.
  `void`
  `addInstanceFilter(ObjectReference instance)`
  Restricts the events generated by this request to those in which the currently executing instance ("this") is the object specified.
  `void`
  `addThreadFilter(ThreadReference thread)`
  Restricts the events generated by this request to those in the given thread.
  `ReferenceType`
  `exception()`
  Returns exception type for which exception events are requested.
  `boolean`
  `notifyCaught()`
  Returns whether caught exceptions of the requested type will generate events when they are thrown.
  `boolean`
  `notifyUncaught()`
  Returns whether uncaught exceptions of the requested type will generate events when they are thrown.

  ### Methods declared in interface com.sun.jdi.request.EventRequest

  `addCountFilter, disable, enable, getProperty, isEnabled, putProperty, setEnabled, setSuspendPolicy, suspendPolicy`

  ### Methods declared in interface com.sun.jdi.Mirror

  `toString, virtualMachine`

- ## Method Details

  - ### exception

    ReferenceType exception()
    Returns exception type for which exception events are requested.
    Returns:
      The exception (and its subclasses) requested with `EventRequestManager.createExceptionRequest(com.sun.jdi.ReferenceType, boolean, boolean)`, or null if, as by default, all exceptions are requested.

  - ### notifyCaught

    boolean notifyCaught()
    Returns whether caught exceptions of the requested type will generate events when they are thrown.

    Note that at the time an exception is thrown, it is not always possible to determine whether it is truly caught. See `ExceptionEvent.catchLocation()` for details.

    Returns:
      boolean true if caught exceptions will be reported, false otherwise.

  - ### notifyUncaught

    boolean notifyUncaught()
    Returns whether uncaught exceptions of the requested type will generate events when they are thrown.

    Note that at the time an exception is thrown, it is not always possible to determine whether it is truly uncaught. See `ExceptionEvent.catchLocation()` for details.

    Returns:
      boolean true if caught exceptions will be reported, false otherwise.

  - ### addThreadFilter

    void addThreadFilter(ThreadReference thread)
    Restricts the events generated by this request to those in the given thread.
    Parameters:
      `thread` - the thread to filter on.
    Throws:
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

  - ### addClassFilter

    void addClassFilter(ReferenceType refType)
    Restricts the events generated by this request to those whose location is in the given reference type or any of its subtypes. An event will be generated for any location in a reference type that can be safely cast to the given reference type.
    Parameters:
      `refType` - the reference type to filter on.
    Throws:
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

  - ### addClassFilter

    void addClassFilter(String classPattern)
    Restricts the events generated by this request to those whose location is in a class whose name matches a restricted regular expression. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".
    Parameters:
      `classPattern` - the pattern String to filter for.
    Throws:
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

  - ### addClassExclusionFilter

    void addClassExclusionFilter(String classPattern)
    Restricts the events generated by this request to those whose location is in a class whose name does not match a restricted regular expression. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".
    Parameters:
      `classPattern` - the pattern String to filter against.
    Throws:
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

  - ### addInstanceFilter

    void addInstanceFilter(ObjectReference instance)
    Restricts the events generated by this request to those in which the currently executing instance ("this") is the object specified.

    Not all targets support this operation. Use `VirtualMachine.canUseInstanceFilters()` to determine if the operation is supported.

    Parameters:
      `instance` - the object which must be the current instance in order to pass this filter.
    Throws:
      `UnsupportedOperationException` - if the target virtual machine does not support this operation.
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.
    Since:
      1.4